## libsrtp2 2.5.0-3+11.0trisquel1

=== debian/changelog ===
libsrtp2 (2.5.0-3+11.0trisquel1) aramo-backports; urgency=medium

  * Backported from debian bookworm as dependency of libtgwot for
    openssl 3.0 support.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 13 Dec 2023 07:59:32 +0000
