=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: libsrtp2
 Priority: optional
-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
