## libsrtp2 2.6.0

=== debian/changelog ===
libsrtp2 (2.6.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update symbols: 1 symbol dropped

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Mar 2024 23:53:46 +0100
