=== debian/changelog ===
libsrtp2 (2.7.0-3) unstable; urgency=medium

  * no-changes source-only upload to enable testing migration

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 13 Apr 2025 15:18:22 +0200

libsrtp2 (2.7.0-2) experimental; urgency=medium

  [ Victor Seva ]
  * flag libsrtp2-docs as Multi-Arch: foreign

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 24 Mar 2025 14:30:57 +0100

libsrtp2 (2.7.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.7.2
  * update copyright info: update coverage
  * update symbols: 1 optional symbol dropped

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 24 Mar 2025 14:24:05 +0100
