=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: libsrtp2
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
@@ -16,7 +16,7 @@
  psmisc,
 Build-Depends-Indep:
  doxygen,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
@@ -73,6 +73,7 @@
 Depends:
  ${misc:Depends},
 Architecture: all
+Multi-Arch: foreign
 Description: Secure RTP (SRTP) and UST Reference Implementations - documentation
  SRTP is a security profile for RTP that adds confidentiality, message
  authentication, and replay protection to that protocol. It is specified
